Added a pipe from the generator to the receiver that communicates
what basis file we used to generate the file data (if it was not
the default name).  This optimizes away the basis-file search in
the receiver and makes future options that do more basis-file
searching more efficient (such as the --fuzzy option and the
support for multiple --compare-dest options).

You must run "make proto" before compiling.

--- orig/generator.c	2004-09-20 19:50:13
+++ generator.c	2004-09-20 19:57:58
@@ -254,14 +254,15 @@ static void generate_and_send_sums(int f
  * out.  It might be wrong.
  */
 static void recv_generator(char *fname, struct file_struct *file, int i,
-			   int f_out)
+			   int f_out, int f_out_name)
 {
-	int fd, f_copy;
+	int fd = -1, f_copy;
 	STRUCT_STAT st, partial_st;
 	struct file_struct *back_file;
 	int statret, stat_errno;
 	char *fnamecmp, *partialptr, *backupptr;
 	char fnamecmpbuf[MAXPATHLEN];
+	uchar fnamecmp_type;
 
 	if (list_only)
 		return;
@@ -423,6 +424,7 @@ static void recv_generator(char *fname, 
 	}
 
 	fnamecmp = fname;
+	fnamecmp_type = G2R_FNAME;
 
 	if (statret == -1 && compare_dest != NULL) {
 		/* try the file at compare_dest instead */
@@ -439,10 +441,14 @@ static void recv_generator(char *fname, 
 							safe_fname(fname));
 					}
 					fnamecmp = fnamecmpbuf;
+					fnamecmp_type = 0;
 				}
 			} else
 #endif
+			{
 				fnamecmp = fnamecmpbuf;
+				fnamecmp_type = 0;
+			}
 			statret = 0;
 		}
 	}
@@ -465,11 +471,9 @@ static void recv_generator(char *fname, 
 	if (statret == -1) {
 		if (preserve_hard_links && hard_link_check(file, HL_SKIP))
 			return;
-		if (stat_errno == ENOENT) {
-			write_int(f_out,i);
-			if (!dry_run && !read_batch)
-				write_sum_head(f_out, NULL);
-		} else if (verbose > 1) {
+		if (stat_errno == ENOENT)
+			goto notify_others;
+		if (verbose > 1) {
 			rsyserr(FERROR, stat_errno,
 				"recv_generator: failed to stat %s",
 				full_fname(fname));
@@ -477,13 +481,13 @@ static void recv_generator(char *fname, 
 		return;
 	}
 
-	if (opt_ignore_existing && fnamecmp == fname) {
+	if (opt_ignore_existing && fnamecmp_type == G2R_FNAME) {
 		if (verbose > 1)
 			rprintf(FINFO, "%s exists\n", safe_fname(fname));
 		return;
 	}
 
-	if (update_only && fnamecmp == fname
+	if (update_only && fnamecmp_type == G2R_FNAME
 	    && cmp_modtime(st.st_mtime, file->modtime) > 0) {
 		if (verbose > 1)
 			rprintf(FINFO, "%s is newer\n", safe_fname(fname));
@@ -491,26 +495,23 @@ static void recv_generator(char *fname, 
 	}
 
 	if (skip_file(fnamecmp, file, &st)) {
-		if (fnamecmp == fname)
+		if (fnamecmp_type == G2R_FNAME)
 			set_perms(fname, file, &st, PERMS_REPORT);
 		return;
 	}
 
 prepare_to_open:
-	if (dry_run || read_batch) {
-		write_int(f_out,i);
-		return;
-	}
-
-	if (whole_file > 0) {
-		write_int(f_out,i);
-		write_sum_head(f_out, NULL);
-		return;
+	if (dry_run || whole_file) {
+		statret = -1;
+		goto notify_others;
 	}
+	if (read_batch)
+		goto notify_others;
 
 	if (partialptr) {
 		st = partial_st;
 		fnamecmp = partialptr;
+		fnamecmp_type = G2R_PARTIAL_DIR;
 	}
 
 	/* open the file */
@@ -523,9 +524,8 @@ prepare_to_open:
 		/* pretend the file didn't exist */
 		if (preserve_hard_links && hard_link_check(file, HL_SKIP))
 			return;
-		write_int(f_out,i);
-		write_sum_head(f_out, NULL);
-		return;
+		statret = -1;
+		goto notify_others;
 	}
 
 	if (inplace && make_backups) {
@@ -552,6 +552,7 @@ prepare_to_open:
 			close(fd);
 			return;
 		}
+		fnamecmp_type = G2R_BACKUP;
 	} else {
 		backupptr = NULL;
 		back_file = NULL;
@@ -566,22 +567,38 @@ prepare_to_open:
 	if (verbose > 2)
 		rprintf(FINFO, "generating and sending sums for %d\n", i);
 
-	write_int(f_out,i);
-	generate_and_send_sums(fd, st.st_size, f_out, f_copy);
-
-	if (f_copy >= 0) {
-		close(f_copy);
-		set_perms(backupptr, back_file, NULL, 0);
-		if (verbose > 1)
-			rprintf(FINFO, "backed up %s to %s\n", fname, backupptr);
-		free(back_file);
+notify_others:
+	if (f_out_name >= 0) {
+		write_byte(f_out_name, fnamecmp_type);
+		io_flush(NORMAL_FLUSH); /* XXX make this more efficient! */
 	}
 
-	close(fd);
+	write_int(f_out, i);
+
+	if (dry_run || read_batch)
+		return;
+
+	if (statret == 0) {
+		generate_and_send_sums(fd, st.st_size, f_out, f_copy);
+
+		if (f_copy >= 0) {
+			close(f_copy);
+			set_perms(backupptr, back_file, NULL, 0);
+			if (verbose > 1) {
+				rprintf(FINFO, "backed up %s to %s\n",
+					fname, backupptr);
+			}
+			free(back_file);
+		}
+
+		close(fd);
+	} else
+		write_sum_head(f_out, NULL);
 }
 
 
-void generate_files(int f_out, struct file_list *flist, char *local_name)
+void generate_files(int f_out, struct file_list *flist, char *local_name,
+		    int f_out_name)
 {
 	int i;
 	int phase = 0;
@@ -622,7 +639,7 @@ void generate_files(int f_out, struct fi
 		}
 
 		recv_generator(local_name ? local_name : f_name_to(file, fbuf),
-			       file, i, f_out);
+			       file, i, f_out, f_out_name);
 	}
 
 	phase++;
@@ -639,7 +656,7 @@ void generate_files(int f_out, struct fi
 	while ((i = get_redo_num()) != -1) {
 		struct file_struct *file = flist->files[i];
 		recv_generator(local_name ? local_name : f_name_to(file, fbuf),
-			       file, i, f_out);
+			       file, i, f_out, f_out_name);
 	}
 
 	phase++;
@@ -658,7 +675,7 @@ void generate_files(int f_out, struct fi
 		if (!file->basename || !S_ISDIR(file->mode))
 			continue;
 		recv_generator(local_name ? local_name : f_name(file),
-			       file, i, -1);
+			       file, i, -1, -1);
 	}
 
 	if (verbose > 2)
--- orig/main.c	2004-09-18 01:49:33
+++ main.c	2004-07-22 00:10:43
@@ -59,6 +59,7 @@ extern int filesfrom_fd;
 extern pid_t cleanup_child_pid;
 extern char *files_from;
 extern char *remote_filesfrom_file;
+extern char *compare_dest;
 extern char *rsync_path;
 extern char *shell_cmd;
 extern char *batch_name;
@@ -461,7 +462,8 @@ static int do_recv(int f_in,int f_out,st
 {
 	int pid;
 	int status = 0;
-	int error_pipe[2];
+	int error_pipe[2], name_pipe[2];
+	BOOL need_name_pipe = compare_dest && !dry_run;
 
 	/* The receiving side mustn't obey this, or an existing symlink that
 	 * points to an identical file won't be replaced by the referent. */
@@ -476,8 +478,9 @@ static int do_recv(int f_in,int f_out,st
 			delete_files(flist);
 	}
 
-	if (fd_pair(error_pipe) < 0) {
-		rprintf(FERROR,"error pipe failed in do_recv\n");
+	if (fd_pair(error_pipe) < 0
+	    || (need_name_pipe && fd_pair(name_pipe) < 0)) {
+		rprintf(FERROR, "fd_pair() failed in do_recv\n");
 		exit_cleanup(RERR_SOCKETIO);
 	}
 
@@ -485,6 +488,11 @@ static int do_recv(int f_in,int f_out,st
 
 	if ((pid = do_fork()) == 0) {
 		close(error_pipe[0]);
+		if (need_name_pipe) {
+			close(name_pipe[1]);
+			set_blocking(name_pipe[0]);
+		} else
+			name_pipe[0] = -1;
 		if (f_in != f_out)
 			close(f_out);
 
@@ -494,7 +502,7 @@ static int do_recv(int f_in,int f_out,st
 		/* set place to send errors */
 		set_msg_fd_out(error_pipe[1]);
 
-		recv_files(f_in,flist,local_name);
+		recv_files(f_in, flist, local_name, name_pipe[0]);
 		io_flush(FULL_FLUSH);
 		report(f_in);
 
@@ -513,6 +521,11 @@ static int do_recv(int f_in,int f_out,st
 		stop_write_batch();
 
 	close(error_pipe[1]);
+	if (need_name_pipe) {
+		close(name_pipe[0]);
+		set_nonblocking(name_pipe[1]);
+	} else
+		name_pipe[1] = -1;
 	if (f_in != f_out)
 		close(f_in);
 
@@ -520,7 +533,7 @@ static int do_recv(int f_in,int f_out,st
 
 	set_msg_fd_in(error_pipe[0]);
 
-	generate_files(f_out, flist, local_name);
+	generate_files(f_out, flist, local_name, name_pipe[1]);
 
 	get_redo_num(); /* Read final MSG_DONE and any prior messages. */
 	report(-1);
--- orig/receiver.c	2004-09-21 09:40:27
+++ receiver.c	2004-09-07 21:57:20
@@ -329,7 +329,8 @@ static void discard_receive_data(int f_i
  * main routine for receiver process.
  *
  * Receiver process runs on the same host as the generator process. */
-int recv_files(int f_in, struct file_list *flist, char *local_name)
+int recv_files(int f_in, struct file_list *flist, char *local_name,
+	       int f_in_name)
 {
 	int next_gen_i = -1;
 	int fd1,fd2;
@@ -358,8 +359,13 @@ int recv_files(int f_in, struct file_lis
 		i = read_int(f_in);
 		if (i == -1) {
 			if (read_batch) {
-				if (next_gen_i != flist->count)
-					while (read_int(batch_gen_fd) != -1) {}
+				if (next_gen_i != flist->count) {
+					do {
+						if (f_in_name >= 0
+						    && next_gen_i >= 0)
+							read_byte(f_in_name);
+					} while (read_int(batch_gen_fd) != -1);
+				}
 				next_gen_i = -1;
 			}
 
@@ -407,6 +413,8 @@ int recv_files(int f_in, struct file_lis
 
 		if (read_batch) {
 			while (i > next_gen_i) {
+				if (f_in_name >= 0 && next_gen_i >= 0)
+					read_byte(f_in_name);
 				next_gen_i = read_int(batch_gen_fd);
 				if (next_gen_i == -1)
 					next_gen_i = flist->count;
@@ -417,6 +425,7 @@ int recv_files(int f_in, struct file_lis
 				discard_receive_data(f_in, file->length);
 				continue;
 			}
+			next_gen_i = -1;
 		}
 
 		if (server_exclude_list.head
@@ -426,35 +435,31 @@ int recv_files(int f_in, struct file_lis
 			exit_cleanup(RERR_PROTOCOL);
 		}
 
-		if (partial_dir) {
-			if ((partialptr = partial_dir_fname(fname)) != NULL)
-				fnamecmp = partialptr;
-			else
+		partialptr = partial_dir ? partial_dir_fname(fname) : fname;
+
+		if (f_in_name >= 0) {
+			switch (read_byte(f_in_name)) {
+			case G2R_FNAME:
 				fnamecmp = fname;
+				break;
+			case G2R_PARTIAL_DIR:
+				fnamecmp = partialptr ? partialptr : fname;
+				break;
+			case G2R_BACKUP:
+				fnamecmp = get_backup_name(fname);
+				break;
+			default:
+				pathjoin(fnamecmpbuf, sizeof fnamecmpbuf,
+					 compare_dest, fname);
+				fnamecmp = fnamecmpbuf;
+				break;
+			}
 		} else
-			fnamecmp = partialptr = fname;
-
-		if (inplace && make_backups) {
-			if (!(fnamecmp = get_backup_name(fname)))
-				fnamecmp = partialptr;
-		}
+			fnamecmp = fname;
 
 		/* open the file */
 		fd1 = do_open(fnamecmp, O_RDONLY, 0);
 
-		if (fd1 == -1 && fnamecmp != fname) {
-			fnamecmp = fname;
-			fd1 = do_open(fnamecmp, O_RDONLY, 0);
-		}
-
-		if (fd1 == -1 && compare_dest != NULL) {
-			/* try the file at compare_dest instead */
-			pathjoin(fnamecmpbuf, sizeof fnamecmpbuf,
-				 compare_dest, fname);
-			fnamecmp = fnamecmpbuf;
-			fd1 = do_open(fnamecmp, O_RDONLY, 0);
-		}
-
 		if (fd1 != -1 && do_fstat(fd1,&st) != 0) {
 			rsyserr(FERROR, errno, "fstat %s failed",
 				full_fname(fnamecmp));
--- orig/rsync.h	2004-08-03 15:41:32
+++ rsync.h	2004-09-07 21:52:22
@@ -118,6 +118,10 @@
 #define PDIR_CREATE	1
 #define PDIR_DELETE	0
 
+#define G2R_FNAME	0x80
+#define G2R_PARTIAL_DIR	0x81
+#define G2R_BACKUP	0x82
+
 
 /* Log-message categories.  FLOG is only used on the daemon side to
  * output messages to the log file. */
